#include "Colors.h"
#include <qrgb.h>

#define deducedFg(bg) (qGray((bg).rgb()) >= 124 ? Qt::black : Qt::white)

QString  Colors::action ()
{
   return QObject::tr("blue");
}

QString  Colors::error ()
{
   return QObject::tr("red");
}

QString  Colors::errorDisabled ()
{
   return QObject::tr("#ffa9b8"); // pink2 from rgb.txt
}

QString  Colors::warning ()
{
   return QObject::tr("darkorange");
}

QString  Colors::minor ()
{
   return QObject::tr("#8b5a2b"); // tan4 from rgb.txt
}

QString  Colors::minorDisabled ()
{
   return QObject::tr("#ffbd94"); // hand-crafted (lighter than tan1)
}

QString  Colors::ok ()
{
   return QObject::tr("green");
}

QString  Colors::requiredBg ()
{
   return QObject::tr("#fffacd"); // lemon chiffon from rgb.txt
}

QString  Colors::errorBg ()
{
   return QObject::tr("#ff6060"); // pale red (pale enough for black fg text)
}

QString  Colors::warningBg ()
{
   return QObject::tr("yellow");
}

QString  Colors::okBg ()
{
   return QObject::tr("lightgreen");
}

QPalette Colors::makeRequired (const QPalette&  p)
{
   static const QColor*  requiredColor = NULL;
   if (requiredColor == NULL) {
      requiredColor = new QColor(requiredBg());
   }

   QPalette result = p;
   result.setColor(QPalette::Active,   QPalette::Base, *requiredColor);
   result.setColor(QPalette::Inactive, QPalette::Base, *requiredColor);
   return result;
}

QPalette Colors::makeError (const QPalette&  p)
{
   QColor  col(errorBg());

   QPalette result = p;
   result.setColor(QPalette::Window, col);
   result.setColor(QPalette::WindowText, deducedFg(col));
   return result;
}

QPalette Colors::makeWarning (const QPalette&  p)
{
   QColor  col(warningBg());

   QPalette result = p;
   result.setColor(QPalette::Window, col);
   result.setColor(QPalette::WindowText, deducedFg(col));
   return result;
}

QPalette Colors::makeOK (const QPalette&  p)
{
   QColor  col(okBg());

   QPalette result = p;
   result.setColor(QPalette::Window, col);
   result.setColor(QPalette::WindowText, deducedFg(col));
   return result;
}
