#ifndef HFrameLabel_h
#define HFrameLabel_h

#include <QFrame>
#include <QHBoxLayout>
#include <QLabel>

// This class creates a label with a frame around it.  However, if the text is
// ever the empty, none of it is drawn.

class HFrameLabel : public QFrame {
public:
   explicit HFrameLabel (QWidget*         parent = NULL,
                         Qt::WindowFlags  f      = 0);
   explicit HFrameLabel (const QString&   text,
                         QWidget*         parent = NULL,
                         Qt::WindowFlags  f      = 0);
public:
   virtual void setText    (const QString&   text);
   virtual void setPalette (const QPalette&  palette);
protected:
   QHBoxLayout*  hbox;
   QLabel*       label;
   QPalette      defaultPalette;
   QPalette      activePalette;
};

#endif
