#ifndef HProgressBar_h
#define HProgressBar_h

#include <QPoint>
#include <QProgressBar>

// QProgressBar with these extensions:
//    Displays the name of an activity along with the percentage
//    Provides a signal for tooltip requests

class HProgressBar : public QProgressBar {
   Q_OBJECT
public:
   explicit HProgressBar(QWidget*  parent = 0);
public:
   QString text() const;
   void setActivity(QString  activity);
public slots:
   void reset();
signals:
   void toolTip(const QPoint&);
protected:
   virtual bool event(QEvent*  ev);
protected:
   QString activity;
};

#endif
